
d=9; // diameter quadratic hole in mm
h=4; // height in mm
p=[0,0,0]; // position in mm
// xml result for MuJoCo in Console window
// after copying & pasting, search & replace ECHO: " by an empty string

module puts(s) {
  echo(str("<b>", s, "</b>ECHO: "));
}


r=d/2;
x=.26794919243112270647255365849413;
y=.10011311969978966079382074457931;
m=.001;
for (a=[30,-30,60,-60,120,-120,150,-150]) {
  translate(p) rotate([0,0,a]) translate([0,r,0]) cube([r*x*2,r*y*2,h],center=true);
  puts(str(
    "&lt;geom type=\"box\" group=\"3\"",
    " size=\"",r*x*m," ",r*y*m," ",h/2*m,"\"",
    " pos=\"",(p[0]-r*(1+y)*sin(a))*m," ",(p[1]+r*(1+y)*cos(a))*m," ",p[2]*m,"\"",
    " euler=\"0 0 ",a,"\"",
    " /&gt;"
  ));
}
