
W = 26; // width in mm
H = 26; // height in mm
Wi = 10; // width insert in mm
Hi = 6.5 + 6.5; // height insert in mm plus reserve
pos_m = [0,0,-.013]; // position in meters
tab = "&nbsp; &nbsp; &nbsp; "; // xml result for MuJoCo in Console window
// after copying & pasting, search & replace ECHO: " by an empty string

module puts(s) {
  echo(str("<b>", s, "</b>ECHO: "));
}

puts(str("&lt;body name='quad pole' childclass='steel' pos='0 0 0'&gt;"));
puts(str(tab, "&lt;joint type='free' /&gt;"));
xs = (W - Wi) / 2;
hb = H - Hi;
translate([0, 0, hb / 2]) cube([Wi, Wi, hb], center = true);
puts(str(tab, "&lt;geom type='box' ",
  "size='", Wi / 2000, " ", Wi / 2000, " ", hb / 2000, "' ",
  "pos='", pos_m[0], " ", pos_m[1], " ", pos_m[2] + hb / 2000, "' />"
));
rc = (W - xs) / 2;
for (i = [0 : 3]) {
  ys = i % 2 ? W : W - 2 * xs;
  a = i * 90;
  x = rc * cos(a);
  y = rc * sin(a);
  %translate([x, y, H / 2]) rotate(a) cube([xs, ys, H], center = true);
  puts(str(tab, "&lt;geom type='box' ",
    "size='", xs / 2000, " ", ys / 2000, " ", H / 2000, "' ",
    "pos='", pos_m[0] + x / 1000, " ", pos_m[1] + y / 1000, " ", pos_m[2] + H / 2000, "' ",
    "euler='0 0 ", a, "' />"
  ));
}
puts(str(tab, "&lt;!--insert insert nut here--&gt;"));
puts(str("&lt;/body&gt;"));
