
#include <windows.h>
#include <process.h>
#include <string>
#include <sstream>
#include <regex>
#include <iostream>
#include <iomanip>
#include <fstream>
#include <cassert>
using namespace std;

#pragma warning(disable: 4244) // '=' : conversion from 'double' to 'float', possible loss of data
const double PI = 3.1415926535897932384626433832795;
inline double cosd(double x) { return cos(x * PI / 180); }
template<class X, class B> inline bool setmin(X& x, B b) { if (X(b) < x) { x = X(b); return true; } else return false; }
template<class X, class B> inline bool setmax(X& x, B b) { if (X(b) > x) { x = X(b); return true; } else return false; }
template<class L, class X> inline X lbound(L l, X x) { return (x >= X(l)) ? x : X(l); }
template<class X, class R> inline X rbound(X x, R r) { return (x <= X(r)) ? x : X(r); }
template<class L, class X, class R> inline X bound(L l, X x, R r) { return (x < X(l)) ? X(l) : (x > X(r)) ? X(r) : x; }
template<class X> inline bool aligned(X x, size_t n) { return ((size_t(x) & (n - 1)) == 0); }
template<class X> inline X sq(X x) { return x * x; }
inline int round32(double x) { return int(floor(x + .5)); }
#define for_(var, count) for (int var = 0; var < (count); var++)
#define verify(expression) { SetLastError(0); if (!(expression)) verify_failed(#expression, __FILE__, __LINE__); }

#include "haptix.h"
#pragma comment(lib, "mjhaptix_user.lib")
#define MJ(mj_function) { if ((mj_function) != mjCOM_OK) mj_function_failed(#mj_function, __FILE__, __LINE__); }
