
Waf = 13; // width across flats in mm (wrench size)
k = 5.3; // thickness in mm
z = 11.875; // z position in mm from M8 thread segment #.scad
cr = 1.25 * .4; // contact ball radius
$fn = 36; // facets number for chamfer
tab = "&nbsp; &nbsp; &nbsp; "; // xml result for MuJoCo in Console window
// after copying & pasting, search & replace ECHO: " by an empty string

module puts(s) {
  echo(str("<b>", s, "</b>ECHO: "));
}

puts(str("&lt;asset&gt;"));
puts(str(tab, "&lt;mesh file='", Waf, " mm hex head.stl' scale='.001 .001 .001' /&gt;"));
puts(str("&lt;/asset&gt;"));
puts(str("&lt;body name='hex head' childclass='steel' pos='0 0 0'&gt;"));
puts(str(tab, "&lt;joint type='free' /&gt;"));
puts(str(tab, "&lt;geom class='nb thread' mesh='", Waf, " mm hex head' pos='0 0 ", z / 1000, "' /&gt;"));

if (1) {
  puts(str(tab, "&lt;!--contact balls for axial clamp force on workpiece--&gt;"));
  r = Waf / 2 / cos(30) - cr * sqrt(1 + pow(tan(30), 2)) + Waf * .01;
  for (i = [0 : 2]) {
    a = i * 120;
    puts(str(tab, "&lt;geom ",
      "class='M8 contact' ",
      "size='", cr / 1000, "' ",
      "pos='", r * cos(a) / 1000, " ", r * sin(a) / 1000, " ", z / 1000, "' ",
      "/&gt;"
    ));
  }
}

puts(str("&lt;/body&gt;"));

intersection() {
  cylinder(d = Waf / cos(30), h = k, $fn = 6);
  h = Waf * sin(30) / cos(30);
  translate([0, 0, 0 - h / 2]) {
    translate([0, 0, k]) cylinder(r1 = Waf, r2 = 0, h = h);
    cylinder(r = Waf, h = k);
  }
}
